;===============================================================================
;
; Wilder Randomness 4.4
;
; - unifies differents random number generators in one single random number
; generator with better randomness
;
;===============================================================================

header
hirom

;===============================================================================
;
; generic random number generator
; 
;===============================================================================
org     $C3F900             ;(*) change for any free space
print "free space used:"
print "...start: ", pc

;-------------------------------------------------------------------------------
random_number_init:
;-------------------------------------------------------------------------------

    ;clean AB
        TDC
        SEP #$20

;-------------------------------------------------------------------------------
random_number:
;-------------------------------------------------------------------------------

    ;backup
        PHX
        PHP

    ;set mode
        SEP #$30            ;1AB, 1XY mode

    ;get random index
        LDA $2137           ;latch h/v counter
        LDA $213C           ;h counter
        ADC $213D           ;v counter
        AND #$03            ;A = [0, 3]
        TAX

    ;get random index 2
        INC $1FA1,X         ;index counter
        LDA $1FA1,X         ;index counter
        TAX

    ;get random number
        LDA $C0FD00,X       ;get random number

    ;exit
        PLP
        PLX
        RTL

;-------------------------------------------------------------------------------
random_veldt:
;-------------------------------------------------------------------------------

    ;get random number
        LDA $021E           ;frame counter: [0, 59]
        AND #$07            ;A = [0, 7]
        INC                 ;A = [1, 8]
        CLC                 ;clear carry
        ADC $1FA5           ;add with actual veldt counter
        STA $1FA5           ;update it

    ;exit
        RTL

print "...end:   ", pc

;===============================================================================
;
; random number generators adjustment
;
;===============================================================================

;-------------------------------------------------------------------------------
org     $C0C3C0
link_c0c3c0:                        ;overworld encounters
;-------------------------------------------------------------------------------

    ;get random number
        JSL random_number_init      ;init and get random number
        NOP : NOP

warnpc  $C0C3C6

;-------------------------------------------------------------------------------
org     $C0C497
link_c0c497:                        ;dungeon encounters
;-------------------------------------------------------------------------------

    ;get random number
        JSL random_number           ;X = random number
        JMP $C4B1                   ;continue code

warnpc  $C0C4B1

;-------------------------------------------------------------------------------
org     $C0C2DF
link_c0c2df:                        ;veldt
;-------------------------------------------------------------------------------

    ;get random veldt number
        JSL random_veldt            ;get random Veldt number
        NOP : NOP

warnpc  $C0C2E5

;-------------------------------------------------------------------------------
org     $C1185C
link_c1185c:                        ;unknow
;-------------------------------------------------------------------------------

    ;get random number
        JSL random_number           ;X = random number
        JMP $1865                   ;continue code

warnpc  $C11865

;-------------------------------------------------------------------------------
org     $C24B5B             
link_c24b5b:                        ;generic random number [0, 255]
;-------------------------------------------------------------------------------

    ;get random number
        JSL random_number           ;X = random number
        JMP $4B63                   ;continue code

warnpc  $C24B63

;-------------------------------------------------------------------------------
org     $C24B6B             
link_c24b6b:                        ;generic random number [0, A-1]
;-------------------------------------------------------------------------------

    ;get random number
        JSL random_number           ;X = random number
        JMP $4B73                   ;continue code

warnpc  $C24B73

;-------------------------------------------------------------------------------
org     $C2BBE7
link_c2bbe7:                        ;generic random number [0, 255]
;-------------------------------------------------------------------------------

    ;get random number
        JSL random_number           ;X = random number
        JMP $BBF0                   ;continue code

warnpc  $C2BBF0
